## uClibc-0.9.19.tar.gz

=== libpthread/Makefile ===
# Makefile for uClibc's pthread library
#
# Copyright (C) 2002 Erik Andersen <andersen@uclibc.org>
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU Library General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU Library General Public License for more
# details.
#
# You should have received a copy of the GNU Library General Public License
# along with this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

TOPDIR=../
include $(TOPDIR)Rules.mak

#Adjust the soname version to avoid namespace collisions with glibc's libpthread
LIBPTHREAD=libpthread.a
LIBPTHREAD_SHARED=libpthread.so
LIBPTHREAD_SHARED_FULLNAME=libpthread-$(MAJOR_VERSION).$(MINOR_VERSION).$(SUBLEVEL).so

LIBTHREAD_DB=libthread_db.a
LIBTHREAD_DB_SHARED=libthread_db.so.1
LIBTHREAD_DB_SHARED_FULLNAME=libthread_db-$(MAJOR_VERSION).$(MINOR_VERSION).$(SUBLEVEL).so

DIRS=
ifeq ($(strip $(UCLIBC_HAS_THREADS)),y)
	DIRS+=linuxthreads
ifeq ($(strip $(DODEBUG)),y)
	DIRS+=linuxthreads_db
endif
endif

ifeq ($(strip $(UCLIBC_CTOR_DTOR)),y)
ifeq ($(strip $(DOPIC)),y)
    START_FILES  = $(TOPDIR)lib/crti.o    $(LIBGCC_DIR)crtbeginS.o
    END_FILES    = $(LIBGCC_DIR)crtendS.o $(TOPDIR)lib/crtn.o
else
    START_FILES  = $(TOPDIR)lib/crti.o    $(LIBGCC_DIR)crtbegin.o
    END_FILES    = $(LIBGCC_DIR)crtend.o  $(TOPDIR)lib/crtn.o
endif
endif

ALL_SUBDIRS = linuxthreads linuxthreads_db

all: $(LIBPTHREAD) $(LIBTHREAD_DB)

$(LIBPTHREAD): subdirs
	@if [ -f $(LIBPTHREAD) ] ; then \
		set -e; \
		install -d $(TOPDIR)lib; \
		rm -f $(TOPDIR)lib/$(LIBPTHREAD); \
		install -m 644 $(LIBPTHREAD) $(TOPDIR)lib; \
	fi;

$(LIBTHREAD_DB): subdirs
	@if [ -f $(LIBTHREAD_DB) ] ; then \
		set -e; \
		install -d $(TOPDIR)lib; \
		rm -f $(TOPDIR)lib/$(LIBTHREAD_DB); \
		install -m 644 $(LIBTHREAD_DB) $(TOPDIR)lib; \
	fi;


$(OBJS): %.o : %.c
	$(CC) $(CFLAGS) -c $< -o $@
	$(STRIPTOOL) -x -R .note -R .comment $*.o

$(OBJ): Makefile

shared: all
	if [ -f $(LIBPTHREAD) ] ; then \
		set -e; \
		$(LD) $(LDFLAGS) -soname=$(LIBPTHREAD_SHARED).$(MAJOR_VERSION) \
			-o $(LIBPTHREAD_SHARED_FULLNAME) $(START_FILES) --whole-archive $(LIBPTHREAD) \
			--no-whole-archive $(TOPDIR)/libc/misc/internals/interp.o \
			-L$(TOPDIR)/lib -lc $(END_FILES); \
		install -d $(TOPDIR)lib; \
		rm -f $(TOPDIR)lib/$(LIBPTHREAD_SHARED_FULLNAME) \
			$(TOPDIR)lib/$(LIBPTHREAD_SHARED).$(MAJOR_VERSION); \
		install -m 644 $(LIBPTHREAD_SHARED_FULLNAME) $(TOPDIR)lib; \
		(cd $(TOPDIR)lib && ln -sf $(LIBPTHREAD_SHARED_FULLNAME) \
			$(LIBPTHREAD_SHARED)); \
		(cd $(TOPDIR)lib && ln -sf $(LIBPTHREAD_SHARED_FULLNAME) \
			$(LIBPTHREAD_SHARED).$(MAJOR_VERSION)); \
	fi;
	if [ -f $(LIBTHREAD_DB) ] ; then \
		set -e; \
		$(LD) $(LDFLAGS) -soname=$(LIBTHREAD_DB_SHARED).$(MAJOR_VERSION) \
			-o $(LIBTHREAD_DB_SHARED_FULLNAME) $(START_FILES) --whole-archive $(LIBTHREAD_DB) \
			--no-whole-archive $(TOPDIR)/libc/misc/internals/interp.o \
			-L$(TOPDIR)/lib -lc $(END_FILES); \
		install -d $(TOPDIR)lib; \
		rm -f $(TOPDIR)lib/$(LIBTHREAD_DB_SHARED_FULLNAME) \
			$(TOPDIR)lib/$(LIBTHREAD_DB_SHARED).$(MAJOR_VERSION); \
		install -m 644 $(LIBTHREAD_DB_SHARED_FULLNAME) $(TOPDIR)lib; \
		(cd $(TOPDIR)lib && ln -sf $(LIBTHREAD_DB_SHARED_FULLNAME) \
			$(LIBTHREAD_DB_SHARED)); \
	fi;

tags:
	ctags -R

subdirs: $(patsubst %, _dir_%, $(DIRS))
subdirs_clean: $(patsubst %, _dirclean_%, $(ALL_SUBDIRS))

$(patsubst %, _dir_%, $(DIRS)) : dummy
	$(MAKE) -C $(patsubst _dir_%, %, $@)

$(patsubst %, _dirclean_%, $(ALL_SUBDIRS)) : dummy
	$(MAKE) -C $(patsubst _dirclean_%, %, $@) clean

clean: subdirs_clean
	rm -f *.[oa] *~ core $(LIBPTHREAD) $(LIBPTHREAD_SHARED_FULLNAME) \
		$(LIBTHREAD_DB) $(LIBTHREAD_DB_SHARED_FULLNAME)

.PHONY: dummy

=== libc/sysdeps/linux/common/Makefile ===
# Makefile for uClibc
#
# Copyright (C) 2000-2003 Erik Andersen <andersen@uclibc.org>
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU Library General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU Library General Public License for more
# details.
#
# You should have received a copy of the GNU Library General Public License
# along with this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

TOPDIR=../../../../
include $(TOPDIR)Rules.mak

CSRC=	waitpid.c getdnnm.c gethstnm.c getcwd.c ptrace.c \
	mkfifo.c setegid.c wait.c getpagesize.c seteuid.c \
	wait3.c setpgrp.c getdtablesize.c create_module.c \
	cmsg_nxthdr.c longjmp.c open64.c ftruncate64.c mmap64.c \
	truncate64.c getrlimit64.c setrlimit64.c creat64.c \
	llseek.c pread_write.c _exit.c sync.c getdirname.c \
	sendfile64.c xstatconv.c getdents.c getdents64.c
ifneq ($(strip $(EXCLUDE_BRK)),y)
CSRC+=sbrk.c
endif
COBJS=$(patsubst %.c,%.o, $(CSRC))

MSRC=syscalls.c
MOBJ=$(shell ./list_syscalls.sh)

CTOR_TARGETS=$(TOPDIR)lib/crti.o $(TOPDIR)lib/crtn.o
SAFECFLAGS=$(XWARNINGS) $(OPTIMIZATION) $(XARCH_CFLAGS) $(CPU_CFLAGS) -fno-builtin
#
# on SH4 addition of -g kills the initfini stuff, removed here for all
# platforms as I suspect no one want initfini compiled -g :-) - davidm
#
SAFECFLAGS := $(subst -g,,$(SAFECFLAGS))
ifeq ($(strip $(DOPIC)),y)
SAFECFLAGS+=-fPIC
endif

OBJ=$(COBJS) $(MOBJ)

all: $(STR_SYSCALLS) $(OBJ) $(LIBC)

$(LIBC): ar-target

ar-target: $(OBJ) $(CTOR_TARGETS)
	$(AR) $(ARFLAGS) $(LIBC) $(OBJ)

$(MOBJ): $(MSRC)
	$(CC) $(CFLAGS) -DL_$* $< -c -o $*.o
	$(STRIPTOOL) -x -R .note -R .comment $*.o

$(COBJS): %.o : %.c
	$(CC) $(CFLAGS) -c $< -o $@
	$(STRIPTOOL) -x -R .note -R .comment $*.o

ifeq ($(strip $(UCLIBC_CTOR_DTOR)),y)
initfini.S: initfini.c
	$(CC) $(SAFECFLAGS) -I$(TOPDIR)include -c initfini.c -S -o initfini.S

crti.S crtn.S: initfini.S $(TOPDIR)/extra/scripts/initfini.awk
	$(AWK) -f $(TOPDIR)extra/scripts/initfini.awk initfini.S

crti.o: crti.S
	$(CC) $(SAFECFLAGS) -c crti.S -o crti.o

$(TOPDIR)lib/crti.o: crti.o
	mkdir -p $(TOPDIR)lib/
	cp crti.o $(TOPDIR)lib/

crtn.o: crtn.S
	$(CC) $(SAFECFLAGS) -c crtn.S -o crtn.o

$(TOPDIR)lib/crtn.o: crtn.o
	mkdir -p $(TOPDIR)lib/
	cp crtn.o $(TOPDIR)lib/
else
$(TOPDIR)lib/crti.o:
	mkdir -p $(TOPDIR)lib/
	$(AR) $(ARFLAGS) $(TOPDIR)lib/crti.o
$(TOPDIR)lib/crtn.o:
	mkdir -p $(TOPDIR)lib/
	$(AR) $(ARFLAGS) $(TOPDIR)lib/crtn.o
endif

clean:
	rm -f *.[oa] *~ core crt[in].* *.S

=== debian/control ===
Source: uclibc
Section: devel
Priority: optional
Maintainer: David Schleef <ds@schleef.org>
Build-Depends: debhelper, bzip2, kernel-source-2.4.20
Standards-Version: 3.5.8

Package: libuclibc-dev
Section: devel
Architecture: alpha arm i386 m68k mips mipsel powerpc sh sparc
Depends: libuclibc0 (= ${Source-Version})
Description: A small implementation of the C library
 uClibc is an implementation of the standard C library that is
 much smaller than glibc, which makes it useful for embedded
 systems.  This package includes header files and development
 libraries necessary to compile applications that use uClibc.

Package: libuclibc0
Section: libs
Architecture: alpha arm i386 m68k mips mipsel powerpc sh sparc
Depends:
Description: A small implementation of the C library
 uClibc is an implementation of the standard C library that is
 much smaller than glibc, which makes it useful for embedded
 systems.  This package provides only the run-time libraries.
 .
 The Debian binary packages for uClibc do not provide the necessary
 components for using uClibc as the primary library on a system,
 as might be done for an embedded system.

Package: uclibc-toolchain
Section: devel
Architecture: alpha arm i386 m68k mips mipsel powerpc sh sparc
Depends: gcc|c-compiler, binutils, ${shlibs:Depends}
Recommends: libuclibc-dev
Conflicts: uclibc-gcc
Replaces: uclibc-gcc
Description: A compiler wrapper for uClibc
 This package includes utilities that function as a toolchain for
 compiling with uClibc instead of the native libc.  The utilities
 have names such as powerpc-uclibc-gcc (depending on the architecture),
 and should behave identically to the base utilities, except that
 they use headers and libraries provided in the libuclibc-dev
 package.  Most utilities are symbolic links to the correct underlying
 utility, although gcc and ld are implemented as wrapper binaries that
 call gcc and ld with the necessary arguments and command line options.
